# ---?---
#
# $Id: key.xs,v 1.2 2004/04/08 01:36:21 mdw Exp $
#
# Key-management interface
#
# (c) 2001 Straylight/Edgeware
#

#----- Licensing notice -----------------------------------------------------
#
# This file is part of the Perl interface to Catacomb.
#
# Catacomb/Perl is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# Catacomb/Perl is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Catacomb/Perl; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

MODULE = Catacomb PACKAGE = Catacomb::Key

MODULE = Catacomb PACKAGE = Catacomb::Key::Data

MODULE = Catacomb PACKAGE = Catacomb::Key::File PREFIX = key_

Key_File *
new(file, how)
	char *file
	unsigned how
	CODE:
	RETVAL = CREATE(key_file);
	if (key_open(RETVAL, file, how, warn_keyreporter, 0)) {
	  DESTROY(RETVAL);
	  RETVAL = 0;
	}
	OUTPUT:
	RETVAL

SV *
DESTROY(kf)
	Key_File *kf
	CODE:
	key_close(kf);
	XSRETURN_UNDEF;

KEYERR
merge(kf, name, fp)
	Key_File *kf
	char *name
	FILE *fp
	CODE:
	RETVAL = key_merge(kf, name, fp, warn_keyreporter, 0);
	OUTPUT:
	RETVAL

SV *
extract

#----- That's all, folks ----------------------------------------------------
